import javax.swing.JPanel;
import javax.swing.JFrame;

import java.awt.FlowLayout;
import java.awt.Dimension;

public class GUIFrame extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	public PaintCanvas mapPanel = null;

	/**
	 * This is the default constructor
	 */
	public GUIFrame() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {

        //GUIの初期化
//		this.setSize(1300, 1150);
		this.setSize(700, 650);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.out.println("windowClosing()"); // TODO Auto-generated Event stub windowClosing()
				System.exit(-1);
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new FlowLayout());
			jContentPane.add(getMapPanel(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes mapPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private PaintCanvas getMapPanel() {
		if (mapPanel == null) {
			mapPanel = new PaintCanvas();
			mapPanel.setLayout(new FlowLayout());
//			mapPanel.setPreferredSize(new Dimension(1200, 1100));
			mapPanel.setPreferredSize(new Dimension(650, 600));
		}
		return mapPanel;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
