import javax.swing.JPanel;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Polygon;
//import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;

//import java.awt.geom.*;
//import java.awt.*;
import java.awt.image.*;
import javax.vecmath.*;
import java.util.Random;

public class PaintCanvas extends JPanel {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	boolean formationMode=true;

	public Color canvas_color = Color.WHITE;  //  @jve:decl-index=0:
	public Color pen_color = Color.GREEN;  //  @jve:decl-index=0:
	public BufferedImage image = null;  //  @jve:decl-index=0:
	public Graphics2D imageGraphics;  //  @jve:decl-index=0:

	public float pensize = 3.0F;

	int gentenX = 0;
	int gentenY = 0;

	public double zoom = 13;	//1ピクセルを何mmにするか？

	int distanceOfTile = 1000;


	public Point2d[] urgPoint=null;

	public Point2d[] nowUrgPoint=null;

	public Point2d[] mapPoint = null;

	public int scrollX = 0;
	public int scrollY = 0;


	int robotNum=0;

	int robotRadius = 220;	//ロボットの半径（マージン付き）[mm]

	public Point2d[][] robotNowUrgPoint=null;

//	Point3d[] robotPos = null;

//	boolean[] robotSellectedFlag =null;
//	boolean[] robotLeaderFlag = null;

//	Point2d targetPoint = null;


	int[] trajectoryXSeq= new int[0];
	int[] trajectoryYSeq= new int[0];

//	Polygon groupPolygon = null;
//	boolean formationPolygonFlag=false;

	int canvasX=0;
	int canvasY=0;

	int mousePointX = 0;
	int mousePointY=0;

	int scrollVerticalFlag=0;
	int scrollHorizontalFlag=0;

	double minX=99999;
	double minY=99999;
	double maxX=-99999;
	double maxY=-99999;
//	Point4d groupRect= null;

//	String startArea ="";
//	String endArea ="";


	MapPenData penData=null;
	MapRobotData robotData[]=null;
	MapGroupData groupData[]=null;

	int maxLrfDistance=0;	//[mm]

	/**
	 * This method initializes
	 *
	 */
	public PaintCanvas() {
		super();
		initialize();
	}


	/**
	 * This method initializes this
	 *
	 */
	private void initialize() {
		//ペンデータのインスタンス化
		penData = new MapPenData(null, null, null);
		//ロボット台数分インスタンス化する。
		robotData = new MapRobotData[robotNum];
		for(int i=0; i<robotNum;i++){
			//１台ごとにインスタンス化
			robotData[i]= new MapRobotData(null, -1 ,0,null);
		}
		this.addMouseWheelListener(new java.awt.event.MouseAdapter() {
        	public void mouseWheelMoved(java.awt.event.MouseWheelEvent e) {
//        		System.out.println("mouseWheelMoved():"+e.getWheelRotation());
        		zoom+=e.getWheelRotation();
        		if(zoom<5){
        			zoom=5;
        		}else{
            		if(e.getWheelRotation()>0){
                		scrollX-=scrollX/zoom;
                		scrollY-=scrollY/zoom;
            		}
            		if(e.getWheelRotation()<0){
                		scrollX+=scrollX/zoom;
                		scrollY+=scrollY/zoom;
            		}
        		}
        		}
		});



        this.addMouseListener(new java.awt.event.MouseAdapter() {
        	public void mouseExited(java.awt.event.MouseEvent e) {
        		System.out.println("mouseExited()"); // TODO Auto-generated Event stub mouseExited()
        		scrollVerticalFlag=0;
        		scrollHorizontalFlag=0;
        	}

        	public void mouseReleased(java.awt.event.MouseEvent e) {
        		//ドラッグ（スケッチ）を止めたときの処理
        		//スケッチ終点がフリーorグループ枠内かを判別。
        		//判別後には、スケッチ始点と終点の領域に基づいて処理を行う。
        		penData.end="free";

				if(groupData !=null){
					for(int i=0;i<groupData.length;i++){
						if(groupData[i] != null){
							if(groupData[i].groupRect != null){
								if(groupData[i].groupRect.contains(e.getX(), e.getY())){	//内外判定
									penData.end=Integer.toString(i);
								}else{
									penData.end="free";
								}
							}else{
								//System.out.println("groupData[i].groupRect == null");
							}
						}else{
							//System.out.println("groupData[i] == null");
						}
					}
				}
        		System.out.println("pen end:"+penData.end);
				System.out.println("---------sckech finish----------------");

				//内外判定はここまで
				//以下は始点エリア、終点エリアに基づく処理を記述

				//s:free + e:group ->何もしない

				//s:group + e:free -> 目標設定
				if(!penData.start.equals("free") && penData.end.equals("free")){
					//ターゲットを指定するグループ
					int targetGroup=Integer.parseInt(penData.start);
					System.out.println("Set Target:"+targetGroup);
					//目標値をセット
					groupData[targetGroup].target = new Point2d(-(int)((e.getY()-gentenY)*zoom), -(int)((e.getX()-gentenX)*zoom));
					if(penData.trajectory != null){
						groupData[targetGroup].targetTrajectry = new Point2d[penData.trajectory.npoints];
						for(int k=0;k<penData.trajectory.npoints;k++){
							int tempX = -(int)((penData.trajectory.ypoints[k]-gentenY)*zoom);
							int tempY = -(int)((penData.trajectory.xpoints[k]-gentenX)*zoom);
							groupData[targetGroup].targetTrajectry[k]=new Point2d(tempX, tempY);
						}
					}
					//一番近いロボットアイコンを探す
//					double minDistance =1000000000;
//					int nearRobotID=-1;
//					for(int i=0;i<robotNum;i++){
//						if(robotData[i].groupID==targetGroup){	//所属しているロボット全部を対象とする
//							double distance = (groupData[targetGroup].target.x - robotData[i].posdata.x)*(groupData[targetGroup].target.x - robotData[i].posdata.x)
//								+(groupData[targetGroup].target.y - robotData[i].posdata.y)*(groupData[targetGroup].target.y - robotData[i].posdata.y);
//							if(distance < minDistance){
//								minDistance = distance;
//								nearRobotID = i;
//							}
//						}
//					}
//					System.out.println("Near robot is "+nearRobotID);
//					for(int i=0;i<robotNum;i++){
//						if(robotData[i].groupID==targetGroup){
//							robotData[i].role=0;	//follow
//						}
//					}
//					if(nearRobotID !=-1){
//						robotData[nearRobotID].role=1;
//					}
				}

				//s:free + e:free ->グループ化

				if(penData.start.equals("free") && penData.end.equals("free")){
					System.out.println("Grouping");
					//グループデータが空のとき
					if(groupData ==null){
						groupData = new MapGroupData[1];
						groupData[0] = new MapGroupData(null, null, -1, null,null, null);
					}else{
						//すでにグループデータが存在するなら後ろに一つ足す。
						MapGroupData[] preGroupData;
						preGroupData = groupData;
						groupData = new MapGroupData[groupData.length+1];
						for(int i=0;i<groupData.length-1;i++){
							groupData[i] = preGroupData[i];
						}
						groupData[groupData.length-1]= new MapGroupData(null,null,-1,null,null, null);
					}

					//グループに所属するロボットのID
					int[] inGroupRobotID = new int[0];

					if(penData.trajectory != null){
						if(robotData !=null){
							for(int i=0;i<robotData.length;i++){
								//ロボットの座標を画面系に変換後、軌跡データに含まれるかチェック
								if(penData.trajectory.contains(-robotData[i].posdata.y/zoom+gentenX, -robotData[i].posdata.x/zoom+gentenY)){
									int[] preID = inGroupRobotID;
									inGroupRobotID = new int[inGroupRobotID.length+1];
									for(int k=0;k<inGroupRobotID.length-1;k++){
										inGroupRobotID[k] = preID[k];
									}
									inGroupRobotID[inGroupRobotID.length-1]=i;
									//System.out.println("robot"+i+" is in the trajectroy circle.");
								}
							}
						}
					}
					groupData[groupData.length-1].robotID = inGroupRobotID;

					//ロボットデータにいったん引き渡して重複をなくす
					for(int i=0;i<groupData[groupData.length-1].robotID.length;i++){
						robotData[groupData[groupData.length-1].robotID[i]].groupID=groupData.length-1;
					}

//					for(int i=0;i<robotNum;i++){
//						System.out.println("robot"+i+"is in group"+robotData[i].groupID);
//					}

					for(int i=0;i<groupData.length;i++){
						groupData[i].robotID = null;
					}
					for(int i=0;i<robotNum;i++){
						if(robotData[i].groupID != -1){
							int[] preRobotID = groupData[robotData[i].groupID].robotID;
							if(preRobotID !=null){
								groupData[robotData[i].groupID].robotID = new int[preRobotID.length+1];
								for(int k=0;k<preRobotID.length;k++){
									groupData[robotData[i].groupID].robotID[k]= preRobotID[k];
								}
							}else{
								groupData[robotData[i].groupID].robotID = new int[1];
							}
							groupData[robotData[i].groupID].robotID[groupData[robotData[i].groupID].robotID.length-1]= i;
						}

					}
					//枠座標の追加
					//選択されたロボット座標のうちx,y座標の最大値を算出
					minX=99999;
					minY=99999;
					maxX=-99999;
					maxY=-99999;
					if(groupData[groupData.length-1].robotID != null){
						for(int i=0;i<groupData[groupData.length-1].robotID.length;i++){
							if(robotData[groupData[groupData.length-1].robotID[i]].posdata.x < minX){
								minX = robotData[groupData[groupData.length-1].robotID[i]].posdata.x;
							}
							if(robotData[groupData[groupData.length-1].robotID[i]].posdata.x > maxX){
								maxX = robotData[groupData[groupData.length-1].robotID[i]].posdata.x;
							}
							if(robotData[groupData[groupData.length-1].robotID[i]].posdata.y < minY){
								minY = robotData[groupData[groupData.length-1].robotID[i]].posdata.y;
							}
							if(robotData[groupData[groupData.length-1].robotID[i]].posdata.y > maxY){
								maxY = robotData[groupData[groupData.length-1].robotID[i]].posdata.y;
							}
						}
						//System.out.println(minX+","+minY+","+maxX+","+maxY);
						int margin=20;
						if(minX !=99999 || minY !=99999 || maxX !=-99999 || maxY !=-99999){
							groupData[groupData.length-1].groupRect = new Polygon();
							groupData[groupData.length-1].groupRect.addPoint((int)(-minY/zoom+gentenX)+margin, (int)(-maxX/zoom+gentenY)-margin);
							groupData[groupData.length-1].groupRect.addPoint((int)(-minY/zoom+gentenX)+margin, (int)(-minX/zoom+gentenY)+margin);
							groupData[groupData.length-1].groupRect.addPoint((int)(-maxY/zoom+gentenX)-margin, (int)(-minX/zoom+gentenY)+margin);
							groupData[groupData.length-1].groupRect.addPoint((int)(-maxY/zoom+gentenX)-margin, (int)(-maxX/zoom+gentenY)-margin);
						}else{
							System.out.println("not select?");
							groupData[groupData.length-1].groupRect=null;
						}
					}
					//groupカラーを乱数から作成
					Random rnd = new Random();
					groupData[groupData.length-1].groupColor = new Color(rnd.nextInt(220),rnd.nextInt(220),rnd.nextInt(220));
				}


				penData.trajectory =null;
				repaint();
			}
        	public void mousePressed(java.awt.event.MouseEvent e) {
        		//マウスを左クリックしたときの動作
        		//書き始めの領域を判断する

				//ペンデータを空にする
				penData.trajectory=null;
				//軌跡一時保存用配列も空にする
				trajectoryXSeq=new int[0];
				trajectoryYSeq=new int[0];

				System.out.println("---------sckech start----------------");
				//Is click point in group rect?
				int pressX = e.getX();
				int pressY = e.getY();
				//System.out.println("press:"+e.getX()+","+e.getY());
				penData.start="free";
				if(groupData !=null){
					//System.out.println("groupData.length:"+groupData.length);
					for(int i=0;i<groupData.length;i++){
						if(groupData[i] != null){
							if(groupData[i].groupRect != null){
								if(groupData[i].groupRect.contains(pressX, pressY)){	//内外判定
									penData.start=Integer.toString(i);
								}else{
									//penData.start="free";
								}
							}else{
								//System.out.println("groupData[i].groupRect == null");
							}
						}else{
							//System.out.println("groupData[i] == null");
						}
					}
				}
				System.out.println("pen start:"+penData.start);
        	}
        	public void mouseClicked(java.awt.event.MouseEvent e) {
				//mouseClickFunction(e);
        		//repaint();
        	}
        });
        this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
        	public void mouseMoved(java.awt.event.MouseEvent e) {
        		mousePointX=e.getX();
        		mousePointY=e.getY();
        		//System.out.println("canvas:"+canvasX+","+canvasY);
        		//System.out.println("mousePoint:"+mousePointX+","+mousePointY);

        		if(mousePointY<(canvasY/30)){
            		scrollVerticalFlag=-1;
        		}else if(mousePointY>(canvasY*29/30)){
            		scrollVerticalFlag=1;
        		}else{
            		scrollVerticalFlag=0;
        		}
        		if(mousePointX<(canvasX/30)){
            		scrollHorizontalFlag=-1;
        		}else if(mousePointX>(canvasX*29/30)){
            		scrollHorizontalFlag=1;
        		}else{
            		scrollHorizontalFlag=0;
        		}


        	}
        	public void mouseDragged(java.awt.event.MouseEvent e) {
        		//ドラッグ時の動作
        		//ドラッグ点をひたすら軌跡配列に保存する

				int preTrajectoryXSeq[]=new int[trajectoryXSeq.length];
				for(int i=0;i<preTrajectoryXSeq.length;i++){
					preTrajectoryXSeq[i]=trajectoryXSeq[i];
				}

				int preTrajectoryYSeq[]=new int[trajectoryYSeq.length];
				for(int i=0;i<preTrajectoryYSeq.length;i++){
					preTrajectoryYSeq[i]=trajectoryYSeq[i];
				}
				trajectoryXSeq = new int[preTrajectoryXSeq.length+1];
				trajectoryYSeq = new int[preTrajectoryYSeq.length+1];

				for(int i=0;i<preTrajectoryXSeq.length;i++){
					trajectoryXSeq[i] = preTrajectoryXSeq[i];
					trajectoryYSeq[i] = preTrajectoryYSeq[i];
				}
				trajectoryXSeq[trajectoryXSeq.length-1] =e.getX();
				trajectoryYSeq[trajectoryYSeq.length-1] =e.getY();

				penData.trajectory=new Polygon(trajectoryXSeq, trajectoryYSeq, trajectoryXSeq.length);
				repaint();
			}
        });
        this.setSize(new Dimension(263, 239));
	}


	public void paintComponent(Graphics g){
		super.paintComponent(g);
		Graphics2D g2d = (Graphics2D) g;
		if(image==null){
			Dimension d = getSize();
			int w = d.width;
			int h = d.height;
			image = (BufferedImage)createImage(w,h);
			imageGraphics = (Graphics2D)image.createGraphics();
			imageGraphics.setBackground(canvas_color);
			imageGraphics.clearRect(0,0,w,h);
			imageGraphics.setPaint(pen_color);
			imageGraphics.setStroke(new BasicStroke(pensize));
		}
		imageGraphics.setPaint(pen_color);
		imageGraphics.setStroke(new BasicStroke(pensize));

		canvasX = this.getWidth();
		canvasY = this.getHeight();

		if(scrollHorizontalFlag==-1){
			scrollX+=10;
		}else if(scrollHorizontalFlag==1){
			scrollX-=10;
		}else{

		}

		if(scrollVerticalFlag==-1){
			scrollY+=10;
		}else if(scrollVerticalFlag==1){
			scrollY-=10;
		}else{

		}


		gentenX = getSize().width/2 + scrollX;
//		gentenY = 2 * getSize().height/3 + scrollY;
		gentenY = getSize().height/2 + scrollY;

//		imageGraphics.setColor(Color.WHITE);
		imageGraphics.setColor(Color.GRAY);
		imageGraphics.fillRect(0,0,getSize().width,getSize().height);

		int urgX=0, urgY=0;

		if(robotNowUrgPoint != null){
			for(int i=0;i<robotNum;i++){
				if(robotNowUrgPoint[i] != null){


					//フリースペースポリゴン用
					Polygon freeSpace;
					int[] xSeq=new int[robotNowUrgPoint[i].length];
					int[] ySeq=new int[robotNowUrgPoint[i].length];

					for(int k=0; k<robotNowUrgPoint[i].length; k++){
						if(robotNowUrgPoint[i][k] != null){
							urgY = (int)-robotNowUrgPoint[i][k].x;
							urgX = (int)-robotNowUrgPoint[i][k].y;

							xSeq[k]=(int)(urgX/zoom+gentenX);
							ySeq[k]=(int)(urgY/zoom+gentenY);
						}

//						if(robotLeaderFlag[i])	imageGraphics.setColor(Color.BLUE);
//						else if(robotSellectedFlag[i])	imageGraphics.setColor(Color.GREEN);
//						else	imageGraphics.setColor(Color.RED);
						imageGraphics.setColor(Color.BLUE);
//						imageGraphics.setColor(new Color(0,50+i*30,250-i*30));

//						imageGraphics.fillOval((int)((urgX/zoom+gentenX)-3),(int)((urgY/zoom+gentenY)-3),6,6);

					}

					freeSpace = new Polygon(xSeq, ySeq, xSeq.length);
					imageGraphics.setColor(Color.white);
					imageGraphics.fillPolygon(freeSpace);

					for(int k=0;k<xSeq.length;k++){
						if(robotNowUrgPoint[i][k] !=null){
							if(!(robotNowUrgPoint[i][k].distance(new Point2d(robotData[i].posdata.x,robotData[i].posdata.y)) > (maxLrfDistance-20))){
								imageGraphics.setColor(Color.BLUE);
								imageGraphics.fillOval((int)(xSeq[k]-2),(int)(ySeq[k]-2),4,4);
							}
						}
					}

				}
			}
		}

		for(int i=0; i<100; i++){
			imageGraphics.setColor(Color.DARK_GRAY);
			imageGraphics.setStroke(new BasicStroke(1.0f));
			imageGraphics.drawLine((int)(gentenX+i*distanceOfTile/zoom), 0, (int)(gentenX+i*distanceOfTile/zoom), getSize().height);
			imageGraphics.drawLine((int)(gentenX-i*distanceOfTile/zoom), 0, (int)(gentenX-i*distanceOfTile/zoom), getSize().height);
			imageGraphics.drawLine(0, (int)(gentenY+i*distanceOfTile/zoom), getSize().width, (int)(gentenY+i*distanceOfTile/zoom));
			imageGraphics.drawLine(0, (int)(gentenY-i*distanceOfTile/zoom), getSize().width, (int)(gentenY-i*distanceOfTile/zoom));
		}



		//目標地点の描画
		if(groupData != null){
			for(int i=0;i<groupData.length;i++){
				if(groupData[i].target !=null && groupData[i].robotID !=null){
					if(groupData[i].robotID.length !=0){

						for(int k=0;k<robotNum;k++){
//							if(robotData[k].groupID==i && robotData[k].role==1){
							if(robotData[k].groupID==i){

								Point2d drawTargetPoint = new Point2d(groupData[i].target.x, groupData[i].target.y);
								imageGraphics.setColor(groupData[i].groupColor);
								imageGraphics.setStroke(new BasicStroke(2.0f));
								imageGraphics.drawOval((int)(-drawTargetPoint.y/zoom+gentenX-(100/zoom)), (int)(-drawTargetPoint.x/zoom+gentenY-(100/zoom)),(int)(200/zoom),(int)(200/zoom));
								imageGraphics.drawOval((int)(-drawTargetPoint.y/zoom+gentenX-(70/zoom)), (int)(-drawTargetPoint.x/zoom+gentenY-(70/zoom)),(int)(140/zoom),(int)(140/zoom));
								imageGraphics.drawLine((int)(-drawTargetPoint.y/zoom+gentenX-(120/zoom)), (int)(-drawTargetPoint.x/zoom+gentenY),(int)(-drawTargetPoint.y/zoom+gentenX+(120/zoom)), (int)(-drawTargetPoint.x/zoom+gentenY));
								imageGraphics.drawLine((int)(-drawTargetPoint.y/zoom+gentenX), (int)(-drawTargetPoint.x/zoom+gentenY-(120/zoom)),(int)(-drawTargetPoint.y/zoom+gentenX), (int)(-drawTargetPoint.x/zoom+gentenY+(120/zoom)));
								imageGraphics.drawString("Target"+i,(int)(-drawTargetPoint.y/zoom+gentenX-(100/zoom)), (int)(-drawTargetPoint.x/zoom+gentenY-(100/zoom)));
								imageGraphics.setStroke(new BasicStroke(1.0f));

								//ターゲットとリーダを線で結ぶ
//								int leaderX=(int)(-robotData[k].posdata.y/zoom+gentenX);
//								int leaderY=(int)(-robotData[k].posdata.x/zoom+gentenY);
//								imageGraphics.setColor(Color.LIGHT_GRAY);
//								imageGraphics.drawLine((int)(-drawTargetPoint.y/zoom+gentenX), (int)(-drawTargetPoint.x/zoom+gentenY), leaderX, leaderY);

								//trajectoryデータを表示する
								if(groupData[i].targetTrajectry != null){
									imageGraphics.setColor(groupData[i].groupColor);
									if(groupData[i].targetTrajectry != null){
										for(int j=0;j<groupData[i].targetTrajectry.length;j++){
											if(groupData[i].targetTrajectry[j] != null){
												int tempX=(int)(-groupData[i].targetTrajectry[j].y/zoom+gentenX);
												int tempY=(int)(-groupData[i].targetTrajectry[j].x/zoom+gentenY);
												//System.out.println("trajectry:"+groupData[i].targetTrajectry[j]);
												imageGraphics.fillOval(tempX-3, tempY-3, 6, 6);
												if(j!=0){
													int tempXpre=(int)(-groupData[i].targetTrajectry[j-1].y/zoom+gentenX);
													int tempYpre=(int)(-groupData[i].targetTrajectry[j-1].x/zoom+gentenY);
													imageGraphics.setStroke(new BasicStroke(3.0f));
													imageGraphics.drawLine(tempX, tempY, tempXpre, tempYpre);
													imageGraphics.setStroke(new BasicStroke(1.0f));
												}
											}
										}
									}
									imageGraphics.setColor(Color.black);
								}
							}

						}

					}
				}
			}
		}

		//ロボットアイコンと目的地を結ぶ線の描画
//			for(int i=0;i<robotNum;i++){
//				if(robotLeaderFlag[i]){
//					int leaderX=(int)(-robotPos[i].y/zoom+gentenX);
//					int leaderY=(int)(-robotPos[i].x/zoom+gentenY);
//					imageGraphics.setColor(Color.LIGHT_GRAY);
//					imageGraphics.drawLine((int)(-targetPoint.y/zoom+gentenX), (int)(-targetPoint.x/zoom+gentenY), leaderX, leaderY);
//				}
//			}
//		}

		String fontName="";
		fontName ="Neuropol";
		Font font;


		//ロボットアイコンの描画
		for(int k=0; k<robotNum;k++){
			if(robotData[k].posdata !=null){
				imageGraphics.setColor(Color.RED);
				if(groupData !=null){
					if(robotData[k] != null){
						if(robotData[k].groupID != -1){
							if(groupData[robotData[k].groupID] != null){
								if(groupData[robotData[k].groupID].groupColor != null){
									imageGraphics.setColor(groupData[robotData[k].groupID].groupColor);
								}
							}
						}
					}
				}
				//imageGraphics.setColor(new Color(0,50+k*30,250-k*30));

//				if(robotLeaderFlag[k])	imageGraphics.setColor(Color.BLUE);
//				else if(robotSellectedFlag[k])	imageGraphics.setColor(Color.GREEN);
//				else	imageGraphics.setColor(Color.RED);

				imageGraphics.fillOval((int)(-robotData[k].posdata.y/zoom+gentenX-(robotRadius/zoom)),
						(int)(-robotData[k].posdata.x/zoom+gentenY-(robotRadius/zoom)),
						(int)(robotRadius*2/zoom),(int)(robotRadius*2/zoom));
				Vector3d v = new Vector3d(-(robotRadius*1.1), 0, 0);
				Matrix3d Rz = new Matrix3d();
				Rz.rotZ(-robotData[k].posdata.z);
				Rz.transform(v);
				Point2d robotAngle = new Point2d(-v.x, -v.y);
				imageGraphics.setStroke(new BasicStroke((float)(100.0/zoom)));
				imageGraphics.drawLine((int)(-robotData[k].posdata.y/zoom+gentenX),
						(int)(-robotData[k].posdata.x/zoom+gentenY),
						(int)(-(robotData[k].posdata.y+robotAngle.y)/zoom+gentenX),
						(int)(-(robotData[k].posdata.x+robotAngle.x)/zoom+gentenY));
				imageGraphics.setStroke(new BasicStroke(1.0f));

				if(groupData !=null){
					if(robotData[k] != null){
						if(robotData[k].groupID != -1){
							if(groupData[robotData[k].groupID] != null){
								if(groupData[robotData[k].groupID].groupColor != null){
									imageGraphics.setColor(groupData[robotData[k].groupID].groupColor);
									imageGraphics.setColor(new Color(
											groupData[robotData[k].groupID].groupColor.getRed(),
											groupData[robotData[k].groupID].groupColor.getGreen(),
											groupData[robotData[k].groupID].groupColor.getBlue(),
											150));
								}
							}
						}
					}
				}


				if(robotData[k].velocity !=null){
					//速度の表示
					//3桁分にする
					double testV= (int)(robotData[k].velocity.x*100)/100.0;
					double testW= (int)(robotData[k].velocity.y*100)/100.0;
					imageGraphics.drawString("("+testV+", "+testW+")", (int)(-robotData[k].posdata.y/zoom+gentenX+(robotRadius*0.9/zoom)), (int)(-robotData[k].posdata.x/zoom+gentenY+(robotRadius*1.0/zoom)));
				}else{
					imageGraphics.setColor(new Color(255,0,0,150));
					if(groupData !=null){
						if(robotData[k] != null){
							if(robotData[k].groupID != -1){
								if(groupData[robotData[k].groupID] != null){
									if(groupData[robotData[k].groupID].groupColor != null){
										imageGraphics.setColor(groupData[robotData[k].groupID].groupColor);
										imageGraphics.setColor(new Color(
												groupData[robotData[k].groupID].groupColor.getRed(),
												groupData[robotData[k].groupID].groupColor.getGreen(),
												groupData[robotData[k].groupID].groupColor.getBlue(),
												150));
									}
								}
							}
						}
					}


					imageGraphics.drawString("(0.00, 0.00)", (int)(-robotData[k].posdata.y/zoom+gentenX+(robotRadius*0.9/zoom)), (int)(-robotData[k].posdata.x/zoom+gentenY+(robotRadius*1.0/zoom)));

				}

				font=new Font(fontName,Font.PLAIN,(int)(15));
				imageGraphics.setFont(font);
				imageGraphics.setColor(Color.white);
				imageGraphics.setStroke(new BasicStroke(4.0f));
//				if(robotData[k].role==1)	imageGraphics.drawString("L", (int)(-robotData[k].posdata.y/zoom+gentenX-(50/zoom)), (int)(-robotData[k].posdata.x/zoom+gentenY+(60/zoom)));
				imageGraphics.drawString(Integer.toString(k), (int)(-robotData[k].posdata.y/zoom+gentenX-(60/zoom)), (int)(-robotData[k].posdata.x/zoom+gentenY+(60/zoom)));
				imageGraphics.setStroke(new BasicStroke(1.0f));

			}
		}


		//ペンの軌跡線の描画
		if(penData.trajectory != null){
			if(trajectoryXSeq !=null && trajectoryYSeq !=null){
				imageGraphics.setColor(Color.orange);
				for(int i=0;i<trajectoryXSeq.length;i++){
					int tempX=trajectoryXSeq[i];
					int tempY=trajectoryYSeq[i];
//					imageGraphics.fillOval(trajectoryXSeq[i]-1, trajectoryYSeq[i]-1, 2, 2);
					if(i!=0){
						int tempXpre= trajectoryXSeq[i-1];
						int tempYpre= trajectoryYSeq[i-1];
						imageGraphics.setStroke(new BasicStroke(3.0f));
						imageGraphics.drawLine(tempX, tempY, tempXpre, tempYpre);
						imageGraphics.setStroke(new BasicStroke(1.0f));
					}
				}
				imageGraphics.setColor(Color.black);
			}
		}

		//単位の描画
		font=new Font(fontName,Font.PLAIN,15);
		imageGraphics.setFont(font);

		imageGraphics.setColor(Color.black);
		imageGraphics.drawString(distanceOfTile+"mm squares", 10, getSize().height-20);

		font=new Font(fontName,Font.PLAIN,(int)(15));
		imageGraphics.setFont(font);


		//全ロボットのグループ枠をロボットの移動に合わせて更新
		if(groupData !=null){
			for(int i=0;i<groupData.length;i++){
				//選択されたロボット座標のうちx,y座標の最大値を算出
				minX=99999;
				minY=99999;
				maxX=-99999;
				maxY=-99999;
				if(groupData[i].robotID != null){
					for(int k=0; k<groupData[i].robotID.length;k++){
						if(robotData[groupData[i].robotID[k]].posdata.x < minX){
							minX = robotData[groupData[i].robotID[k]].posdata.x;
						}
						if(robotData[groupData[i].robotID[k]].posdata.x > maxX){
							maxX = robotData[groupData[i].robotID[k]].posdata.x;
						}
						if(robotData[groupData[i].robotID[k]].posdata.y < minY){
							minY = robotData[groupData[i].robotID[k]].posdata.y;
						}
						if(robotData[groupData[i].robotID[k]].posdata.y > maxY){
							maxY = robotData[groupData[i].robotID[k]].posdata.y;
						}
					}
				}
//				System.out.println(minX+","+minY+","+maxX+","+maxY);

				int margin=20;
				if(minX !=99999 || minY !=99999 || maxX !=-99999 || maxY !=-99999){
					groupData[i].groupRect = new Polygon();
					groupData[i].groupRect.addPoint((int)(-minY/zoom+gentenX)+margin, (int)(-maxX/zoom+gentenY)-margin);
					groupData[i].groupRect.addPoint((int)(-minY/zoom+gentenX)+margin, (int)(-minX/zoom+gentenY)+margin);
					groupData[i].groupRect.addPoint((int)(-maxY/zoom+gentenX)-margin, (int)(-minX/zoom+gentenY)+margin);
					groupData[i].groupRect.addPoint((int)(-maxY/zoom+gentenX)-margin, (int)(-maxX/zoom+gentenY)-margin);
				}else{
					//System.out.println("not select?");
					groupData[i].groupRect=null;
				}
			}
		}

		//グループ枠線の描画
		if(groupData !=null){
			for(int i=0;i<groupData.length;i++){
				if(groupData[i].groupRect != null){
					imageGraphics.setColor(groupData[i].groupColor);
					imageGraphics.drawPolygon(groupData[i].groupRect);
					imageGraphics.drawString("Group"+i, groupData[i].groupRect.xpoints[0], groupData[i].groupRect.ypoints[0]);
				}
			}
		}

		//原点の描画
		imageGraphics.setColor(Color.GREEN);
		imageGraphics.fillOval(gentenX-3,gentenY-3,6,6);


		((Graphics2D)g).drawImage(image,0,0,this);
		//p1.setLocation(p2);
		g2d.drawImage(image,0,0,this);
	}


}  //  @jve:decl-index=0:visual-constraint="10,10"
